//
#ifndef BMS_L_SORT_H
#define BMS_L_SORT_H

#include <windows.h>

#include "bmsfel.h"

#define APP_NAME            "BMS List Sorter"
#define APP_VERSION         "[PROTOTYPE 1]"

#define MAIN_WIND_CLASSNAME "BMS_L_SORT"

// EBhEʒup萔
#define WIND_WIDTH_DEFAULT  400
#define WIND_HEIGHT_DEFAULT 600

#define HEADER_WIDTH 200
#define GROUP_WIDTH  HEADER_WIDTH - 2
#define TAB_X        HEADER_WIDTH
#define GROUP_PADDING_TOP   15
#define GROUP_PADDING_LEFT   5
#define GROUP_PADDING_RIGHT 10
#define GROUP_BETWEEN       10
#define LABEL_HEIGHT 15
#define EDIT_HEIGHT  20
#define TAB_PADDING_TOP    22
#define TAB_PADDING_LEFT    3
#define TAB_PADDING_RIGHT   7
#define TAB_PADDING_BOTTOM 26

#define LIST_COUNT 2

// Rg[p萔
#define GROUP_STR        "HEADERS"
#define LABEL_TITLE_STR  "TITLE"
#define LABEL_GENRE_STR  "GENRE"
#define LABEL_ARTIST_STR "ARTIST"

// Rg[pID萔pwb_
#include "bmslsort_rc.h"

// *.init@Cp萔
#define INI_SECTION_WINDOW "Window"
#define INI_POINT_X "point_x"
#define INI_POINT_Y "point_y"
#define INI_WIDTH   "width"
#define INI_HEIGHT  "height"
#define INI_SECTION_FILE "File"
#define INI_LAST_OPEN_DIR "last_open_dir"

// \[X萔`pwb_t@C
#include "bmslsort_rc.h"

// Rg[̃XgBmsRegistArrayтNXi\̓IɎgj
class BothList {
public:
  HWND h_wnd;
  BmsRegistArray *bms;
};

// O[oϐ

// *.init@C̃pX
extern char ini_filename[MAX_PATH];
// ݊JĂBMSt@C
extern BmsBms *bms;
// ݊JĂBMSt@C̃pXƃfBNg
extern char bms_path[MAX_PATH];
extern char bms_dir[MAX_PATH];

// ֐`

// CEBhẼvV[W
LRESULT CALLBACK main_wind_proc( HWND h_wnd, UINT msg, WPARAM wp, LPARAM lp );

// str = BMS̃pX bms_pathbms_dirɃRs[
// 2,3̓Zbg邩ǂ̃tO falseȂ""ɂȂ
bool set_bms_path_dir( char *str, bool path, bool dir );

// EBhE^CgύX
void set_window_title( HWND h_wnd );

// str = pXt@Cɂ
void edit_basename( char *str );

// Bms̃XĝQӏւāÃIuWFSς
void exchange_bms_list_wav( int nth_a, int nth_b );
void exchange_bms_list_bmp( int nth_a, int nth_b );

// Bms̃Xg̈ړ
// startend܂łup( true =>  false =>  )Ɉړ
// ړƂɍ݂͍̂Ōɂ
void move_bms_list_wav( int start, int end, bool up );
void move_bms_list_bmp( int start, int end, bool up );

// BMSɃIuWF邩ǂ̃Xg쐬
void get_exist_list_wav( bool *list );
void get_exist_list_bmp( bool *list );

// BMS\͊֐
BmsBms *read_bms( char *file_name );
// BMSo͊֐
bool write_bms( char *file_name );

#endif // BMS_L_SORT_H
